module dmd.TemplateMixin;

import dmd.TemplateInstance;
import dmd.Array;
import dmd.Type;
import dmd.ArrayTypes;
import dmd.Loc;
import dmd.Identifier;
import dmd.Dsymbol;
import dmd.Scope;
import dmd.OutBuffer;
import dmd.HdrGenState;

class TemplateMixin : TemplateInstance
{
    Array idents;
    Type tqual;

    this(Loc loc, Identifier ident, Type tqual, Array idents, Objects tiargs)
	{
		super(loc, cast(Identifier)idents.data[idents.dim - 1]);
		//printf("TemplateMixin(ident = '%s')\n", ident ? ident.toChars() : "");
		this.ident = ident;
		this.tqual = tqual;
		this.idents = idents;
		this.tiargs = tiargs ? tiargs : new Objects();
	}
	
    Dsymbol syntaxCopy(Dsymbol s)
	{
		assert(false);
	}
	
    void semantic(Scope sc)
	{
		assert(false);
	}
	
    void semantic2(Scope sc)
	{
		assert(false);
	}
	
    void semantic3(Scope sc)
	{
		assert(false);
	}
	
    void inlineScan()
	{
		assert(false);
	}
	
    string kind()
	{
		assert(false);
	}
	
    bool oneMember(Dsymbol* ps)
	{
		assert(false);
	}
	
    bool hasPointers()
	{
		assert(false);
	}
	
    string toChars()
	{
		assert(false);
	}
	
    void toCBuffer(OutBuffer buf, HdrGenState* hgs)
	{
		assert(false);
	}

    void toObjFile(int multiobj)			// compile to .obj file
	{
		assert(false);
	}

    TemplateMixin isTemplateMixin() { return this; }
}